︠197e7813-bb41-464a-bf18-a38199c42585i︠
%html
<h2>Approximating Integrals</h2>
<p><strong>Note:</strong>&nbsp; This worksheet is a modified version of the worksheet found at <a href="../../pub/1385/" target="_blank">http://www.sagenb.org/home/pub/1385/</a>.</p>
<p>The following allows you to interactively explore various rules for approximating integrals. You can change the function, the interval, the number of subintervals in the partition and the approximation rule to use.</p>
<p><strong>Warning:&nbsp; </strong>For Simpson's rule, you need to choose an even number of subintervals in order to approximate the integral on the entire interval.</p>

︡e068c167-29c5-4382-aba6-662a31b9d00b︡{"html": "<h2>Approximating Integrals</h2>\r\n<p><strong>Note:</strong>&nbsp; This worksheet is a modified version of the worksheet found at <a href=\"../../pub/1385/\" target=\"_blank\">http://www.sagenb.org/home/pub/1385/</a>.</p>\r\n<p>The following allows you to interactively explore various rules for approximating integrals. You can change the function, the interval, the number of subintervals in the partition and the approximation rule to use.</p>\r\n<p><strong>Warning:&nbsp; </strong>For Simpson's rule, you need to choose an even number of subintervals in order to approximate the integral on the entire interval.</p>"}︡
︠8be0e1dc-b458-4ae3-a765-a66881a3bb9aai︠
%hide
%auto
load DATA+"illustrate_numerical_integration.sage"
︡013e1aa9-dc7f-4303-aece-dcb79b3c1df7︡︡
︠e099c4cd-7df2-4f6f-a2d1-4609cf81687dai︠
%hide
%auto
@interact
def interact_function(  function = input_box(default = x*sin(x^2)+5, type = SR, label="f(x)"),
        interval=range_slider(-5, 5, 1, default=(3, 4), label="Interval"),
        n = slider(1, 30, 1, default=2, label="Number of subintervals"),
        rule = selector(['none', 'left', 'right', 'midpoint', 'trapezoid', 'Simpson'],
        nrows=1, label="Approximation rule", default="none"),
        show_formula = checkbox(default=False, label="Show Formula"),
        ):
    return illustrate_numerical_integration(function, interval, n, rule, show_formula)
︡0c12c45e-3224-42af-9bf2-5cac345da5d6︡{"html": "<!--notruncate-->\n        <div padding=6 id=\"div-interact-2\">\n          <table width=800px height=20px bgcolor=\"#c5c5c5\" cellpadding=15>\n            <tr>\n              <td bgcolor=\"#f9f9f9\" valign=top align=left>\n            <table>\n              <tr><td colspan=3><table><tr><td align=right><font color=\"black\">f(x)&nbsp;</font></td><td><input type=\"text\" value=\"x*sin(x^2) + 5\" size=80 onchange=\"interact(2, {variable: 'function', adapt_number: 1, value: encode64(this.value)}, 1)\"></input></td>\n</tr><tr><td align=right><font color=\"black\">Interval&nbsp;</font></td><td>\n        <table>\n          <tr>\n            <td>\n              <div id=\"slider-interval-2\" style=\"margin:0px; margin-left: 1.0em; margin-right: 1.0em; width: 20.0em;\"></div>\n            </td>\n          </tr>\n          \n          <tr>\n            <td>\n              <font color=\"black\" id=\"slider-interval-2-lbl\"></font>\n            </td>\n          </tr>\n        </table>\n        <script>\n         (function() {\n             var values = [\"-5\",\"-4\",\"-3\",\"-2\",\"-1\",\"0\",\"1\",\"2\",\"3\",\"4\",\"5\"], pos = [8, 9], sel = '#slider-interval-2', updatePos;\n             updatePos = function() {\n                 pos[0] = $(sel).slider('values', 0);\n                 pos[1] = $(sel).slider('values', 1);\n                 if (values != null) {\n                     $(sel + '-lbl').text('(' + values[pos[0]] + ', ' +\n                                          values[pos[1]] + ')');\n                 }\n             };\n             setTimeout(function() {\n                 $(sel).slider({\n                     range: true,\n                     step: 1,\n                     min: 0,\n                     max: 10,\n                     values: [8, 9],\n                     change: function (e, ui) {\n                         updatePos();\n                         interact(2, {variable: 'interval', adapt_number: 2, value: encode64(pos[0]+' '+pos[1])}, 1);\n                     },\n                     slide: updatePos\n                 });\n                 updatePos();\n             }, 1);\n         })();\n         </script></td>\n</tr><tr><td align=right><font color=\"black\">Number of subintervals&nbsp;</font></td><td>\n        <table>\n          <tr>\n            <td>\n              <div id=\"slider-n-2\" style=\"margin:0px; margin-left: 1.0em; margin-right: 1.0em; width: 15.0em;\"></div>\n            </td>\n            \n            <td>\n              <font color=\"black\" id=\"slider-n-2-lbl\"></font>\n            </td>\n          </tr>\n        </table><script>\n    (function() {\n        var values = [\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\",\"11\",\"12\",\"13\",\"14\",\"15\",\"16\",\"17\",\"18\",\"19\",\"20\",\"21\",\"22\",\"23\",\"24\",\"25\",\"26\",\"27\",\"28\",\"29\",\"30\"];\n        setTimeout(function() {\n            $('#slider-n-2').slider({\n                step: 1,\n                min: 0,\n                max: 29,\n                value: 1,\n                change: function (e, ui) {\n                    var position = ui.value;\n                    if (values != null) {\n                        $('#slider-n-2-lbl').text(values[position]);\n                        interact(2, {variable: 'n', adapt_number: 3, value: encode64(position)}, 1);\n                    }\n                },\n                slide: function (e, ui) {\n                    if (values != null) {\n                        $('#slider-n-2-lbl').text(values[ui.value]);\n                    }\n                }\n            });\n            if (values != null) {\n                $('#slider-n-2-lbl').text(values[$('#slider-n-2').slider('value')]);\n            }\n        }, 1);\n    })();\n    </script></td>\n</tr><tr><td align=right><font color=\"black\">Approximation rule&nbsp;</font></td><td><table style=\"border:1px solid #dfdfdf; background-color:#efefef;\">\n<tr><td><button style=\"border-style:inset;\" value=\"0\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(2, {variable: 'rule', adapt_number: 4, value: encode64(this.value)}, 1)\">none</button>\n<button style=\"border-style:outset;\" value=\"1\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(2, {variable: 'rule', adapt_number: 4, value: encode64(this.value)}, 1)\">left</button>\n<button style=\"border-style:outset;\" value=\"2\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(2, {variable: 'rule', adapt_number: 4, value: encode64(this.value)}, 1)\">right</button>\n<button style=\"border-style:outset;\" value=\"3\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(2, {variable: 'rule', adapt_number: 4, value: encode64(this.value)}, 1)\">midpoint</button>\n<button style=\"border-style:outset;\" value=\"4\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(2, {variable: 'rule', adapt_number: 4, value: encode64(this.value)}, 1)\">trapezoid</button>\n<button style=\"border-style:outset;\" value=\"5\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(2, {variable: 'rule', adapt_number: 4, value: encode64(this.value)}, 1)\">Simpson</button>\n</td></tr></table></td>\n</tr><tr><td align=right><font color=\"black\">Show Formula&nbsp;</font></td><td><input type=\"checkbox\"  width=200px onchange=\"interact(2, {variable: 'show_formula', adapt_number: 5, value: encode64(this.checked)}, 1)\"></input></td>\n</tr></table></td></tr>\n              <tr><td></td><td style='width: 100%;'>\n        <div id=\"cell-interact-2\"><?__SAGE__START>\n          <table border=0 bgcolor=\"white\" width=100%>\n            <tr>\n              <td bgcolor=\"white\" align=left valign=top>\n                <pre><?__SAGE__TEXT></pre>\n              </td>\n            </tr>\n            <tr>\n              <td align=left valign=top><?__SAGE__HTML></td>\n            </tr>\n          </table><?__SAGE__END>\n        </div></td><td></td></tr>\n              <tr><td colspan=3></td></tr>\n            </table></td>\n            </tr>\n          </table>\n        </div>"}︡
︠7214f06f-145e-4f20-8199-5ee55dd3e509ai︠
%hide
%auto
@interact
def interact_function(  function = input_box(default = x*sin(x^2)+5, type = SR, label="f(x)"),
        interval=range_slider(-5, 5, 1, default=(3, 4), label="Interval"),
        n = slider(1, 30, 1, default=2, label="Number of subintervals"),
        rule = selector(['none', 'left', 'right', 'midpoint', 'trapezoid', 'Simpson'],
        nrows=1, label="Approximation rule", default="none"),
        show_formula = checkbox(default=False, label="Show Formula"),
        ):
    return illustrate_numerical_integration(function, interval, n, rule, show_formula)
︡2a764dc1-1d14-4992-8927-e0be8c318cec︡{"html": "<!--notruncate-->\n        <div padding=6 id=\"div-interact-30\">\n          <table width=800px height=20px bgcolor=\"#c5c5c5\" cellpadding=15>\n            <tr>\n              <td bgcolor=\"#f9f9f9\" valign=top align=left>\n            <table>\n              <tr><td colspan=3><table><tr><td align=right><font color=\"black\">f(x)&nbsp;</font></td><td><input type=\"text\" value=\"x*sin(x^2) + 5\" size=80 onchange=\"interact(30, {variable: 'function', adapt_number: 6, value: encode64(this.value)}, 1)\"></input></td>\n</tr><tr><td align=right><font color=\"black\">Interval&nbsp;</font></td><td>\n        <table>\n          <tr>\n            <td>\n              <div id=\"slider-interval-30\" style=\"margin:0px; margin-left: 1.0em; margin-right: 1.0em; width: 20.0em;\"></div>\n            </td>\n          </tr>\n          \n          <tr>\n            <td>\n              <font color=\"black\" id=\"slider-interval-30-lbl\"></font>\n            </td>\n          </tr>\n        </table>\n        <script>\n         (function() {\n             var values = [\"-5\",\"-4\",\"-3\",\"-2\",\"-1\",\"0\",\"1\",\"2\",\"3\",\"4\",\"5\"], pos = [8, 9], sel = '#slider-interval-30', updatePos;\n             updatePos = function() {\n                 pos[0] = $(sel).slider('values', 0);\n                 pos[1] = $(sel).slider('values', 1);\n                 if (values != null) {\n                     $(sel + '-lbl').text('(' + values[pos[0]] + ', ' +\n                                          values[pos[1]] + ')');\n                 }\n             };\n             setTimeout(function() {\n                 $(sel).slider({\n                     range: true,\n                     step: 1,\n                     min: 0,\n                     max: 10,\n                     values: [8, 9],\n                     change: function (e, ui) {\n                         updatePos();\n                         interact(30, {variable: 'interval', adapt_number: 7, value: encode64(pos[0]+' '+pos[1])}, 1);\n                     },\n                     slide: updatePos\n                 });\n                 updatePos();\n             }, 1);\n         })();\n         </script></td>\n</tr><tr><td align=right><font color=\"black\">Number of subintervals&nbsp;</font></td><td>\n        <table>\n          <tr>\n            <td>\n              <div id=\"slider-n-30\" style=\"margin:0px; margin-left: 1.0em; margin-right: 1.0em; width: 15.0em;\"></div>\n            </td>\n            \n            <td>\n              <font color=\"black\" id=\"slider-n-30-lbl\"></font>\n            </td>\n          </tr>\n        </table><script>\n    (function() {\n        var values = [\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\",\"11\",\"12\",\"13\",\"14\",\"15\",\"16\",\"17\",\"18\",\"19\",\"20\",\"21\",\"22\",\"23\",\"24\",\"25\",\"26\",\"27\",\"28\",\"29\",\"30\"];\n        setTimeout(function() {\n            $('#slider-n-30').slider({\n                step: 1,\n                min: 0,\n                max: 29,\n                value: 1,\n                change: function (e, ui) {\n                    var position = ui.value;\n                    if (values != null) {\n                        $('#slider-n-30-lbl').text(values[position]);\n                        interact(30, {variable: 'n', adapt_number: 8, value: encode64(position)}, 1);\n                    }\n                },\n                slide: function (e, ui) {\n                    if (values != null) {\n                        $('#slider-n-30-lbl').text(values[ui.value]);\n                    }\n                }\n            });\n            if (values != null) {\n                $('#slider-n-30-lbl').text(values[$('#slider-n-30').slider('value')]);\n            }\n        }, 1);\n    })();\n    </script></td>\n</tr><tr><td align=right><font color=\"black\">Approximation rule&nbsp;</font></td><td><table style=\"border:1px solid #dfdfdf; background-color:#efefef;\">\n<tr><td><button style=\"border-style:inset;\" value=\"0\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(30, {variable: 'rule', adapt_number: 9, value: encode64(this.value)}, 1)\">none</button>\n<button style=\"border-style:outset;\" value=\"1\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(30, {variable: 'rule', adapt_number: 9, value: encode64(this.value)}, 1)\">left</button>\n<button style=\"border-style:outset;\" value=\"2\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(30, {variable: 'rule', adapt_number: 9, value: encode64(this.value)}, 1)\">right</button>\n<button style=\"border-style:outset;\" value=\"3\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(30, {variable: 'rule', adapt_number: 9, value: encode64(this.value)}, 1)\">midpoint</button>\n<button style=\"border-style:outset;\" value=\"4\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(30, {variable: 'rule', adapt_number: 9, value: encode64(this.value)}, 1)\">trapezoid</button>\n<button style=\"border-style:outset;\" value=\"5\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(30, {variable: 'rule', adapt_number: 9, value: encode64(this.value)}, 1)\">Simpson</button>\n</td></tr></table></td>\n</tr><tr><td align=right><font color=\"black\">Show Formula&nbsp;</font></td><td><input type=\"checkbox\"  width=200px onchange=\"interact(30, {variable: 'show_formula', adapt_number: 10, value: encode64(this.checked)}, 1)\"></input></td>\n</tr></table></td></tr>\n              <tr><td></td><td style='width: 100%;'>\n        <div id=\"cell-interact-30\"><?__SAGE__START>\n          <table border=0 bgcolor=\"white\" width=100%>\n            <tr>\n              <td bgcolor=\"white\" align=left valign=top>\n                <pre><?__SAGE__TEXT></pre>\n              </td>\n            </tr>\n            <tr>\n              <td align=left valign=top><?__SAGE__HTML></td>\n            </tr>\n          </table><?__SAGE__END>\n        </div></td><td></td></tr>\n              <tr><td colspan=3></td></tr>\n            </table></td>\n            </tr>\n          </table>\n        </div>"}︡
